/*	
 *	fmem1.c
 *
 *	tbV \tgEFAID vO
 *	Copyright (C) 2002 Naoyuki Sawa
 *
 *	* Tue Jul  9 21:06:00 JST 2002 Naoyuki Sawa
 *	- 쐬JnB
 */
#include <piece.h>
#include <s1c33cpu.h>
#include "c33209.h"

/****************************************************************************
 *
 ****************************************************************************/

#define FMEM ((unsigned short*)0xc00000) /* tbṼx[XAhX */

unsigned char vbuff[DISP_X * DISP_Y];	/* zVRAM   */
unsigned short manufacturer_id;		/* ID   */
unsigned short device_id;		/* foCXID */

void software_id();

/****************************************************************************
 *	pceAppInit
 ****************************************************************************/

void
pceAppInit()
{
	/* ʓIȏB */
	pceLCDDispStop();
	pceLCDSetBuffer(vbuff);
	pceLCDDispStart();

	/* \tgEFAIDǂݍ݁B */
	software_id();
}

/****************************************************************************
 *	pceAppProc
 ****************************************************************************/

void
pceAppProc(int count)
{
	int pad, x, y;
	char* str;

	pad = pcePadGet();
	if(pad & TRG_SELECT) {
		pceAppReqExit(0);
		return;
	}

	memset(vbuff, 0, sizeof vbuff);
	x = 0;
	y = 0;

	/* ID\B */
	switch(manufacturer_id) {
	case 0x00bf:
		str = "SST";
		break;
	default:
		str = "s";
		break;
	}
	pceFontSetPos(x, y);
	pceFontPrintf("E  \n@%04x(%s)", manufacturer_id, str);
	y += 20;

	/* foCXID\B */
	switch(device_id) {
	case 0x2789:
		str = "SST39LF/VF200A";
		break;
	case 0x2780:
		str = "SST39LF/VF400A";
		break;
	case 0x2781:
		str = "SST39LF/VF800A";
		break;
	default:
		str = "s";
		break;
	}
	pceFontSetPos(x, y);
	pceFontPrintf("EfoCX\n@%04x(%s)", device_id, str);

	pceLCDTrans();
}

/****************************************************************************
 *	pceAppExit
 ****************************************************************************/

void
pceAppExit()
{
}

/****************************************************************************
 *	software_id
 ****************************************************************************/

void
software_id()
{
	volatile unsigned short* c1p = FMEM + 0x5555;
	volatile unsigned short* c2p = FMEM + 0x2aaa;
	unsigned char saveNMI;

DISABLE;
	/* EHb`hbO^C}~B */
	saveNMI = bWD_EN_EWD;
	bWD_WP_WRWD = 1;
	bWD_EN_EWD = 0;

	/* \tgEFAID[hɓ܂B */
	*c1p = 0xaa;
	*c2p = 0x55;
	*c1p = 0x90;

	/* IDAfoCXIDǂݍ݂܂B */
	manufacturer_id = FMEM[0x0000];
	device_id       = FMEM[0x0001];

	/* \tgEFAID[h𔲂܂B
	 * mɔ邱ƁI
	 * * [h⏑݃[h̏ꍇ́AKȊO̎菇ƎIɒʏ탂[hɕA܂A
	 *   \tgEFAID[h̏ꍇ́A񃂁[hɓĂ܂ƁAIɃR}h𔭍s
	 *   [h𔲂ȂA܂ł\tgEFAID[ĥ܂܂łB
	 * * \tgEFAID[hł́A[0x0000],[0x0001]ȊO̓ǂݍ݂́AS0xffffԂ悤łB
	 *   ]āA\tgEFAID[hɓ܂܃tbVBIOSvOɐ䂪ڂƁA
	 *   ߃R[h͑S0xffffƌȂĂ܂A\܂B
	 * * \Ă܂ꍇAwʂ̃Zbg{^Ă܂I
	 *   tbVւ̃ZbgM͂Ȃ̂ŁACPUZbgĂtbV
	 *   \tgEFAID[ĥ܂܂łB
	 * * \畜ɂ́AUSBP[uƓdrOāA΂炭uĂ܂B
	 *   ƂA10bxł̓_łBtbV[hoĂ悤łB
	 *   15buĂƁA܂B
	 */
	*c1p = 0xaa;
	*c2p = 0x55;
	*c1p = 0xf0;

	/* EHb`hbO^C}B */
	bWD_WP_WRWD = 1;
	bWD_EN_EWD = saveNMI;
ENABLE;
}
